/* symbol.c generated by valac, the Vala compiler
 * generated from symbol.vala, do not modify */

/* symbol.vala
 *
 * Copyright (C) 2008-2009 Florian Brosch, Didier Villevalois
 * Copyright (C) 2011      Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Didier 'Ptitjes Villevalois <ptitjes@free.fr>
 */

#include <glib.h>
#include <glib-object.h>
#include "valadoc.h"
#include <valagee.h>
#include <stdlib.h>
#include <string.h>

enum  {
	VALADOC_API_SYMBOL_0_PROPERTY,
	VALADOC_API_SYMBOL_IS_DEPRECATED_PROPERTY,
	VALADOC_API_SYMBOL_ACCESSIBILITY_PROPERTY,
	VALADOC_API_SYMBOL_IS_PUBLIC_PROPERTY,
	VALADOC_API_SYMBOL_IS_PROTECTED_PROPERTY,
	VALADOC_API_SYMBOL_IS_INTERNAL_PROPERTY,
	VALADOC_API_SYMBOL_IS_PRIVATE_PROPERTY,
	VALADOC_API_SYMBOL_NUM_PROPERTIES
};
static GParamSpec* valadoc_api_symbol_properties[VALADOC_API_SYMBOL_NUM_PROPERTIES];
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ValadocApiSymbolPrivate {
	ValaArrayList* attributes;
	gboolean _is_deprecated;
	ValadocApiSymbolAccessibility _accessibility;
};


static gpointer valadoc_api_symbol_parent_class = NULL;

#define VALADOC_API_SYMBOL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALADOC_API_TYPE_SYMBOL, ValadocApiSymbolPrivate))
static void valadoc_api_symbol_set_accessibility (ValadocApiSymbol* self, ValadocApiSymbolAccessibility value);
G_GNUC_INTERNAL void valadoc_api_package_register_deprecated_symbol (ValadocApiPackage* self, ValadocApiSymbol* symbol, const gchar* version);
static void valadoc_api_symbol_set_is_deprecated (ValadocApiSymbol* self, gboolean value);
static gboolean valadoc_api_symbol_real_is_browsable (ValadocApiNode* base, ValadocSettings* settings);
static void valadoc_api_symbol_finalize (GObject * obj);
static void _vala_valadoc_api_symbol_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_valadoc_api_symbol_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


ValadocApiSymbol* valadoc_api_symbol_construct (GType object_type, ValadocApiNode* parent, ValadocApiSourceFile* file, const gchar* name, ValadocApiSymbolAccessibility accessibility, void* data) {
	ValadocApiSymbol * self = NULL;
	ValadocApiNode* _tmp0_;
	ValadocApiSourceFile* _tmp1_;
	const gchar* _tmp2_;
	void* _tmp3_;
	ValadocApiSymbolAccessibility _tmp4_;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	_tmp0_ = parent;
	_tmp1_ = file;
	_tmp2_ = name;
	_tmp3_ = data;
	self = (ValadocApiSymbol*) valadoc_api_node_construct (object_type, _tmp0_, _tmp1_, _tmp2_, _tmp3_);
	_tmp4_ = accessibility;
	valadoc_api_symbol_set_accessibility (self, _tmp4_);
	return self;
}


void valadoc_api_symbol_add_attribute (ValadocApiSymbol* self, ValadocApiAttribute* att) {
	ValaArrayList* _tmp0_;
	ValadocApiAttribute* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	ValaArrayList* _tmp37_;
	ValadocApiAttribute* _tmp38_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (att != NULL);
	_tmp0_ = self->priv->attributes;
	if (_tmp0_ == NULL) {
		GEqualFunc _tmp1_;
		ValaArrayList* _tmp2_;
		_tmp1_ = g_direct_equal;
		_tmp2_ = vala_array_list_new (VALADOC_API_TYPE_ATTRIBUTE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp1_);
		_vala_iterable_unref0 (self->priv->attributes);
		self->priv->attributes = _tmp2_;
	}
	_tmp3_ = att;
	_tmp4_ = valadoc_api_attribute_get_name (_tmp3_);
	_tmp5_ = _tmp4_;
	if (g_strcmp0 (_tmp5_, "Version") == 0) {
		ValadocApiAttributeArgument* deprecated = NULL;
		ValadocApiAttribute* _tmp6_;
		ValadocApiAttributeArgument* _tmp7_;
		ValadocApiAttributeArgument* version = NULL;
		ValadocApiAttribute* _tmp8_;
		ValadocApiAttributeArgument* _tmp9_;
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		ValadocApiAttributeArgument* _tmp12_;
		_tmp6_ = att;
		_tmp7_ = valadoc_api_attribute_get_argument (_tmp6_, "deprecated");
		deprecated = _tmp7_;
		_tmp8_ = att;
		_tmp9_ = valadoc_api_attribute_get_argument (_tmp8_, "deprecated_since");
		version = _tmp9_;
		_tmp12_ = deprecated;
		if (_tmp12_ != NULL) {
			ValadocApiAttributeArgument* _tmp13_;
			gboolean _tmp14_;
			_tmp13_ = deprecated;
			_tmp14_ = valadoc_api_attribute_argument_get_value_as_boolean (_tmp13_);
			_tmp11_ = _tmp14_;
		} else {
			_tmp11_ = FALSE;
		}
		if (_tmp11_) {
			_tmp10_ = TRUE;
		} else {
			ValadocApiAttributeArgument* _tmp15_;
			_tmp15_ = version;
			_tmp10_ = _tmp15_ != NULL;
		}
		if (_tmp10_) {
			gchar* _tmp16_ = NULL;
			ValadocApiAttributeArgument* _tmp17_;
			gchar* version_str = NULL;
			gchar* _tmp20_;
			ValadocApiPackage* _tmp21_;
			ValadocApiPackage* _tmp22_;
			const gchar* _tmp23_;
			_tmp17_ = version;
			if (_tmp17_ != NULL) {
				ValadocApiAttributeArgument* _tmp18_;
				gchar* _tmp19_;
				_tmp18_ = version;
				_tmp19_ = valadoc_api_attribute_argument_get_value_as_string (_tmp18_);
				_g_free0 (_tmp16_);
				_tmp16_ = _tmp19_;
			} else {
				_g_free0 (_tmp16_);
				_tmp16_ = NULL;
			}
			_tmp20_ = g_strdup (_tmp16_);
			version_str = _tmp20_;
			_tmp21_ = valadoc_documentation_get_package ((ValadocDocumentation*) self);
			_tmp22_ = _tmp21_;
			_tmp23_ = version_str;
			valadoc_api_package_register_deprecated_symbol (_tmp22_, self, _tmp23_);
			valadoc_api_symbol_set_is_deprecated (self, TRUE);
			_g_free0 (version_str);
			_g_free0 (_tmp16_);
		}
		_g_object_unref0 (version);
		_g_object_unref0 (deprecated);
	} else {
		ValadocApiAttribute* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		_tmp24_ = att;
		_tmp25_ = valadoc_api_attribute_get_name (_tmp24_);
		_tmp26_ = _tmp25_;
		if (g_strcmp0 (_tmp26_, "Deprecated") == 0) {
			ValadocApiAttributeArgument* version = NULL;
			ValadocApiAttribute* _tmp27_;
			ValadocApiAttributeArgument* _tmp28_;
			gchar* _tmp29_ = NULL;
			ValadocApiAttributeArgument* _tmp30_;
			gchar* version_str = NULL;
			gchar* _tmp33_;
			ValadocApiPackage* _tmp34_;
			ValadocApiPackage* _tmp35_;
			const gchar* _tmp36_;
			_tmp27_ = att;
			_tmp28_ = valadoc_api_attribute_get_argument (_tmp27_, "version");
			version = _tmp28_;
			_tmp30_ = version;
			if (_tmp30_ != NULL) {
				ValadocApiAttributeArgument* _tmp31_;
				gchar* _tmp32_;
				_tmp31_ = version;
				_tmp32_ = valadoc_api_attribute_argument_get_value_as_string (_tmp31_);
				_g_free0 (_tmp29_);
				_tmp29_ = _tmp32_;
			} else {
				_g_free0 (_tmp29_);
				_tmp29_ = NULL;
			}
			_tmp33_ = g_strdup (_tmp29_);
			version_str = _tmp33_;
			_tmp34_ = valadoc_documentation_get_package ((ValadocDocumentation*) self);
			_tmp35_ = _tmp34_;
			_tmp36_ = version_str;
			valadoc_api_package_register_deprecated_symbol (_tmp35_, self, _tmp36_);
			valadoc_api_symbol_set_is_deprecated (self, TRUE);
			_g_free0 (version_str);
			_g_free0 (_tmp29_);
			_g_object_unref0 (version);
		}
	}
	_tmp37_ = self->priv->attributes;
	_tmp38_ = att;
	vala_collection_add ((ValaCollection*) _tmp37_, _tmp38_);
}


static gpointer _vala_iterable_ref0 (gpointer self) {
	return self ? vala_iterable_ref (self) : NULL;
}


ValaCollection* valadoc_api_symbol_get_attributes (ValadocApiSymbol* self) {
	ValaCollection* result = NULL;
	ValaArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->attributes;
	if (_tmp0_ == NULL) {
		GEqualFunc _tmp1_;
		ValaArrayList* _tmp2_;
		_tmp1_ = g_direct_equal;
		_tmp2_ = vala_array_list_new (VALADOC_API_TYPE_ATTRIBUTE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp1_);
		result = (ValaCollection*) _tmp2_;
		return result;
	} else {
		ValaArrayList* _tmp3_;
		ValaCollection* _tmp4_;
		_tmp3_ = self->priv->attributes;
		_tmp4_ = _vala_iterable_ref0 ((ValaCollection*) _tmp3_);
		result = _tmp4_;
		return result;
	}
}


ValadocApiAttribute* valadoc_api_symbol_get_attribute (ValadocApiSymbol* self, const gchar* name) {
	ValadocApiAttribute* result = NULL;
	ValaArrayList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = self->priv->attributes;
	if (_tmp0_ != NULL) {
		{
			ValaArrayList* _att_list = NULL;
			ValaArrayList* _tmp1_;
			ValaArrayList* _tmp2_;
			gint _att_size = 0;
			ValaArrayList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _att_index = 0;
			_tmp1_ = self->priv->attributes;
			_tmp2_ = _vala_iterable_ref0 (_tmp1_);
			_att_list = _tmp2_;
			_tmp3_ = _att_list;
			_tmp4_ = vala_collection_get_size ((ValaCollection*) _tmp3_);
			_tmp5_ = _tmp4_;
			_att_size = _tmp5_;
			_att_index = -1;
			while (TRUE) {
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				ValadocApiAttribute* att = NULL;
				ValaArrayList* _tmp9_;
				gint _tmp10_;
				gpointer _tmp11_;
				ValadocApiAttribute* _tmp12_;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				_tmp6_ = _att_index;
				_att_index = _tmp6_ + 1;
				_tmp7_ = _att_index;
				_tmp8_ = _att_size;
				if (!(_tmp7_ < _tmp8_)) {
					break;
				}
				_tmp9_ = _att_list;
				_tmp10_ = _att_index;
				_tmp11_ = vala_list_get ((ValaList*) _tmp9_, _tmp10_);
				att = (ValadocApiAttribute*) _tmp11_;
				_tmp12_ = att;
				_tmp13_ = valadoc_api_attribute_get_name (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = name;
				if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
					result = att;
					_vala_iterable_unref0 (_att_list);
					return result;
				}
				_g_object_unref0 (att);
			}
			_vala_iterable_unref0 (_att_list);
		}
	}
	result = NULL;
	return result;
}


/**
 * {@inheritDoc}
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean valadoc_api_symbol_real_is_browsable (ValadocApiNode* base, ValadocSettings* settings) {
	ValadocApiSymbol * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	ValadocSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp5_ = FALSE;
	ValadocSettings* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp10_ = FALSE;
	ValadocSettings* _tmp11_;
	gboolean _tmp12_;
	ValadocApiItem* pos = NULL;
	ValadocApiItem* _tmp15_;
	ValadocApiItem* _tmp16_;
	ValadocApiItem* _tmp17_;
	self = (ValadocApiSymbol*) base;
	g_return_val_if_fail (settings != NULL, FALSE);
	_tmp1_ = settings;
	_tmp2_ = _tmp1_->_private;
	if (!_tmp2_) {
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp3_ = valadoc_api_symbol_get_is_private (self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp6_ = settings;
	_tmp7_ = _tmp6_->_internal;
	if (!_tmp7_) {
		gboolean _tmp8_;
		gboolean _tmp9_;
		_tmp8_ = valadoc_api_symbol_get_is_internal (self);
		_tmp9_ = _tmp8_;
		_tmp5_ = _tmp9_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		result = FALSE;
		return result;
	}
	_tmp11_ = settings;
	_tmp12_ = _tmp11_->_protected;
	if (!_tmp12_) {
		gboolean _tmp13_;
		gboolean _tmp14_;
		_tmp13_ = valadoc_api_symbol_get_is_protected (self);
		_tmp14_ = _tmp13_;
		_tmp10_ = _tmp14_;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		result = FALSE;
		return result;
	}
	_tmp15_ = valadoc_api_item_get_parent ((ValadocApiItem*) self);
	_tmp16_ = _tmp15_;
	_tmp17_ = _g_object_ref0 (_tmp16_);
	pos = _tmp17_;
	while (TRUE) {
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		ValadocApiItem* _tmp20_;
		ValadocApiItem* _tmp23_;
		ValadocSettings* _tmp24_;
		gboolean _tmp25_;
		ValadocApiItem* _tmp26_;
		ValadocApiItem* _tmp27_;
		ValadocApiItem* _tmp28_;
		ValadocApiItem* _tmp29_;
		_tmp20_ = pos;
		if (_tmp20_ != NULL) {
			ValadocApiItem* _tmp21_;
			_tmp21_ = pos;
			_tmp19_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, VALADOC_API_TYPE_SYMBOL);
		} else {
			_tmp19_ = FALSE;
		}
		if (_tmp19_) {
			ValadocApiItem* _tmp22_;
			_tmp22_ = pos;
			_tmp18_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp22_, VALADOC_API_TYPE_NAMESPACE) == FALSE;
		} else {
			_tmp18_ = FALSE;
		}
		if (!_tmp18_) {
			break;
		}
		_tmp23_ = pos;
		_tmp24_ = settings;
		_tmp25_ = valadoc_api_node_is_browsable ((ValadocApiNode*) G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, VALADOC_API_TYPE_SYMBOL, ValadocApiSymbol), _tmp24_);
		if (_tmp25_ == FALSE) {
			result = FALSE;
			_g_object_unref0 (pos);
			return result;
		}
		_tmp26_ = pos;
		_tmp27_ = valadoc_api_item_get_parent (_tmp26_);
		_tmp28_ = _tmp27_;
		_tmp29_ = _g_object_ref0 (_tmp28_);
		_g_object_unref0 (pos);
		pos = _tmp29_;
	}
	result = TRUE;
	_g_object_unref0 (pos);
	return result;
}


gboolean valadoc_api_symbol_get_is_deprecated (ValadocApiSymbol* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_deprecated;
	result = _tmp0_;
	return result;
}


static void valadoc_api_symbol_set_is_deprecated (ValadocApiSymbol* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (valadoc_api_symbol_get_is_deprecated (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_is_deprecated = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_symbol_properties[VALADOC_API_SYMBOL_IS_DEPRECATED_PROPERTY]);
	}
}


ValadocApiSymbolAccessibility valadoc_api_symbol_get_accessibility (ValadocApiSymbol* self) {
	ValadocApiSymbolAccessibility result;
	ValadocApiSymbolAccessibility _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_accessibility;
	result = _tmp0_;
	return result;
}


static void valadoc_api_symbol_set_accessibility (ValadocApiSymbol* self, ValadocApiSymbolAccessibility value) {
	g_return_if_fail (self != NULL);
	if (valadoc_api_symbol_get_accessibility (self) != value) {
		ValadocApiSymbolAccessibility _tmp0_;
		_tmp0_ = value;
		self->priv->_accessibility = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_symbol_properties[VALADOC_API_SYMBOL_ACCESSIBILITY_PROPERTY]);
	}
}


gboolean valadoc_api_symbol_get_is_public (ValadocApiSymbol* self) {
	gboolean result;
	ValadocApiSymbolAccessibility _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_accessibility;
	result = _tmp0_ == VALADOC_API_SYMBOL_ACCESSIBILITY_PUBLIC;
	return result;
}


gboolean valadoc_api_symbol_get_is_protected (ValadocApiSymbol* self) {
	gboolean result;
	ValadocApiSymbolAccessibility _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_accessibility;
	result = _tmp0_ == VALADOC_API_SYMBOL_ACCESSIBILITY_PROTECTED;
	return result;
}


gboolean valadoc_api_symbol_get_is_internal (ValadocApiSymbol* self) {
	gboolean result;
	ValadocApiSymbolAccessibility _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_accessibility;
	result = _tmp0_ == VALADOC_API_SYMBOL_ACCESSIBILITY_INTERNAL;
	return result;
}


gboolean valadoc_api_symbol_get_is_private (ValadocApiSymbol* self) {
	gboolean result;
	ValadocApiSymbolAccessibility _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_accessibility;
	result = _tmp0_ == VALADOC_API_SYMBOL_ACCESSIBILITY_PRIVATE;
	return result;
}


static void valadoc_api_symbol_class_init (ValadocApiSymbolClass * klass) {
	valadoc_api_symbol_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValadocApiSymbolPrivate));
	((ValadocApiNodeClass *) klass)->is_browsable = (gboolean (*) (ValadocApiNode *, ValadocSettings*)) valadoc_api_symbol_real_is_browsable;
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_api_symbol_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valadoc_api_symbol_set_property;
	G_OBJECT_CLASS (klass)->finalize = valadoc_api_symbol_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_SYMBOL_IS_DEPRECATED_PROPERTY, valadoc_api_symbol_properties[VALADOC_API_SYMBOL_IS_DEPRECATED_PROPERTY] = g_param_spec_boolean ("is-deprecated", "is-deprecated", "is-deprecated", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_SYMBOL_ACCESSIBILITY_PROPERTY, valadoc_api_symbol_properties[VALADOC_API_SYMBOL_ACCESSIBILITY_PROPERTY] = g_param_spec_enum ("accessibility", "accessibility", "accessibility", VALADOC_API_TYPE_SYMBOL_ACCESSIBILITY, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	 * Specifies whether this symbol is public.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_SYMBOL_IS_PUBLIC_PROPERTY, valadoc_api_symbol_properties[VALADOC_API_SYMBOL_IS_PUBLIC_PROPERTY] = g_param_spec_boolean ("is-public", "is-public", "is-public", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	 * Specifies whether this symbol is protected.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_SYMBOL_IS_PROTECTED_PROPERTY, valadoc_api_symbol_properties[VALADOC_API_SYMBOL_IS_PROTECTED_PROPERTY] = g_param_spec_boolean ("is-protected", "is-protected", "is-protected", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	 * Specifies whether this symbol is internal.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_SYMBOL_IS_INTERNAL_PROPERTY, valadoc_api_symbol_properties[VALADOC_API_SYMBOL_IS_INTERNAL_PROPERTY] = g_param_spec_boolean ("is-internal", "is-internal", "is-internal", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/**
	 * Specifies whether this symbol is private.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_SYMBOL_IS_PRIVATE_PROPERTY, valadoc_api_symbol_properties[VALADOC_API_SYMBOL_IS_PRIVATE_PROPERTY] = g_param_spec_boolean ("is-private", "is-private", "is-private", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void valadoc_api_symbol_instance_init (ValadocApiSymbol * self) {
	self->priv = VALADOC_API_SYMBOL_GET_PRIVATE (self);
	self->priv->_is_deprecated = FALSE;
}


static void valadoc_api_symbol_finalize (GObject * obj) {
	ValadocApiSymbol * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALADOC_API_TYPE_SYMBOL, ValadocApiSymbol);
	_vala_iterable_unref0 (self->priv->attributes);
	G_OBJECT_CLASS (valadoc_api_symbol_parent_class)->finalize (obj);
}


/**
 * Represents a node in the symbol tree.
 */
GType valadoc_api_symbol_get_type (void) {
	static volatile gsize valadoc_api_symbol_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_api_symbol_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValadocApiSymbolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_api_symbol_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocApiSymbol), 0, (GInstanceInitFunc) valadoc_api_symbol_instance_init, NULL };
		GType valadoc_api_symbol_type_id;
		valadoc_api_symbol_type_id = g_type_register_static (VALADOC_API_TYPE_NODE, "ValadocApiSymbol", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&valadoc_api_symbol_type_id__volatile, valadoc_api_symbol_type_id);
	}
	return valadoc_api_symbol_type_id__volatile;
}


static void _vala_valadoc_api_symbol_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValadocApiSymbol * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_SYMBOL, ValadocApiSymbol);
	switch (property_id) {
		case VALADOC_API_SYMBOL_IS_DEPRECATED_PROPERTY:
		g_value_set_boolean (value, valadoc_api_symbol_get_is_deprecated (self));
		break;
		case VALADOC_API_SYMBOL_ACCESSIBILITY_PROPERTY:
		g_value_set_enum (value, valadoc_api_symbol_get_accessibility (self));
		break;
		case VALADOC_API_SYMBOL_IS_PUBLIC_PROPERTY:
		g_value_set_boolean (value, valadoc_api_symbol_get_is_public (self));
		break;
		case VALADOC_API_SYMBOL_IS_PROTECTED_PROPERTY:
		g_value_set_boolean (value, valadoc_api_symbol_get_is_protected (self));
		break;
		case VALADOC_API_SYMBOL_IS_INTERNAL_PROPERTY:
		g_value_set_boolean (value, valadoc_api_symbol_get_is_internal (self));
		break;
		case VALADOC_API_SYMBOL_IS_PRIVATE_PROPERTY:
		g_value_set_boolean (value, valadoc_api_symbol_get_is_private (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_valadoc_api_symbol_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValadocApiSymbol * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_SYMBOL, ValadocApiSymbol);
	switch (property_id) {
		case VALADOC_API_SYMBOL_IS_DEPRECATED_PROPERTY:
		valadoc_api_symbol_set_is_deprecated (self, g_value_get_boolean (value));
		break;
		case VALADOC_API_SYMBOL_ACCESSIBILITY_PROPERTY:
		valadoc_api_symbol_set_accessibility (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



